/*
  Go Communucation sample program
  with gnugo 1.2

  1999-02-10 Hiroshi Yamashita
*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include <time.h>

#include "cgf.h"

///////////////////////////////////////////////////////
// Include gnugo 
///////////////////////////////////////////////////////

#include "gnugo.h"

// change printf function. ---> maybe dangerous...
int printf(const char *fmt, ...)
{
	va_list ap;
	char text[256];

	va_start(ap, fmt);
	vsprintf( text , fmt, ap );
	PRT(text);
	va_end(ap);
	return 1;
}


unsigned char p[19][19];  /* go board */
unsigned char l[19][19];  /* liberty of current color */
unsigned char ma[19][19]; /* working matrix for marking */
unsigned char ml[19][19]; /* working matrix for marking */
int mymove, umove;        /* computer color, opponent color */
int lib;                  /* current stone liberty */
int play;                 /* game state */
int pass;                 /* pass indicator */
int mik, mjk;             /* location of computer stone captured */
int uik, ujk;             /* location of opponent stone captured */
int mk, uk;               /* no. of stones captured by computer and oppoent */
int opn[9];               /* opening pattern flag */


// change from main() 
void initialize_gnugo(void)
  {
//   FILE *fp;
   int i, j;
   char move[10], ans[5];
   int cont = 0;
   time_t tm;

	/* show instruction */
	showinst();

	/* init opening pattern numbers to search */
	for (i = 0; i < 9; i++) opn[i] = 1;

	opn[4] = 0;

	/* init board */
	for (i = 0; i < 19; i++)
		for (j = 0; j < 19; j++)
			p[i][j] = EMPTY;
	/* init global variables */
	mk = 0;  uk = 0;

	/* init global variables */
	play = 1;
	pass = 0;
	mik = -1; mjk = -1;
	uik = -1; ujk = -1;
	srand((unsigned)time(&tm));	/* start random number seed */

	/* ask for handicap */
//	PRT("Number of handicap for black (0 to 17)? ");
//	scanf("%d", &i);
	i = 0;
//	getchar();
	sethand(i);

	/* display game board */
//	showboard();

	/* choose color */
//	PRT("\nChoose side(b or w)? ");
//  scanf("%c",ans);
	ans[0] = 'b';
	if (ans[0] == 'b') {
		mymove = 1;		/* computer white */
		umove = 2;		/* human black */
		if (i) {
			genmove(&i, &j);	/* computer move */
			p[i][j] = mymove;
		}
	} else {
		mymove = 2;				/* computer black */
		umove = 1;				/* human white */
		if (i == 0) {
			genmove(&i, &j);	/* computer move */
			p[i][j] = mymove;
		}
	}
    
//	showboard();
	return;						// stop program.

	/* main loop */
	while ( play > 0) {
		PRT("your move? ");
		scanf("%s", move);
		getmove(move, &i, &j);  /* read human move */
		if (play > 0) {
			if (i >= 0) {		/* not pass */
				p[i][j] = umove;
				examboard(mymove);	 /* remove my dead pieces */
			}
			if (pass != 2) {
			    genmove(&i, &j);	/* computer move */
			    if (i >= 0) {		/* not pass */
					p[i][j] = mymove;
					examboard(umove);   /* remove your dead pieces */
				}
			}
//			showboard();
		}
		if (pass == 2) play = 0;	/* both pass then stop game */
	}

	if (play == 0) {
		/* finish game and count pieces */
//		getchar();
		PRT("Do you want to count score (y or n)? ");
//		scanf("%c",ans);
//		if (ans[0] == 'y') endgame();
	}

//	return 0;
}  /* end main */



// main thinking routine.
int thinking(void)
{
	int z,y,x;

	if ( tesuu & 1 ) { mymove = WHITE;	umove = BLACK; }
	else             { mymove = BLACK;	umove = WHITE; }
						
	x = 0; y = 0;
	genmove(&y, &x);	// computer move 
	if (y >= 0) {		// not pass 
		z = (y+1)*256+(x+1);
//		if ( tesuu > 2 && kifu[tesuu-1][0] == z && kifu[tesuu][0] != 0 ) {
//			z = 0;	// Maybe Ko! change to Pass...
//		} else {
			p[y][x] = mymove;
			examboard(umove);   // remove your dead pieces 
//		}				
	} else z = 0;
					
					
	for (y=0;y<19;y++) {
		for (x=0;x<19;x++) {
			ban[(y+1)*256+(x+1)] = p[y][x];
		}
	}
	return z;
}

/*
// Communication test program source using CGFCOM.DLL version 1.1

// cgfcomlt.h


//comtest.cpp

#define ESC 27
#define STONE_BLACK 1
#include <windows.h>
#include <stdio.h>
#include <iostream.h>
#include <conio.h>

//#include "cgfcomlt.h"
BOOL (*initcom)(int  port);
BOOL (*sendxy)(int x, int y);
BOOL (*receivexy)(int *x, int *y);
BOOL (*newgame)(int color);
BOOL (*closecom)(VOID);

int port_num;
int my_color;
volatile UINT movecount;
int teban;
int ret;
int x,y;
BOOL endgameflag;

void test_cgfcom(void)
{
	HINSTANCE hLib;	// DLL ̃CX^X

	PRT("CGF go-communication test\n");

	hLib = LoadLibrary("cgfcom");	// DLL {̂Ƀ[hB
	if ( hLib == NULL ) {
		PRT("not able to use DLL.");
		return;
	}
	initcom = (BOOL(*)(int))GetProcAddress(hLib,"initcom");	// initcom ֐DLL̒TăAhXZbg
	if(initcom <= 0) {
		FreeLibrary(hLib);	// ֐̃AhX擾ɎŝŁADLLJďIB
		return;
	}
	closecom = (BOOL(*)(VOID))GetProcAddress(hLib,"closecom");
	if(closecom <= 0) {
		FreeLibrary(hLib);
		return;
	}

	sendxy = (BOOL(*)(int, int))GetProcAddress(hLib,"sendxy");
	if(sendxy <= 0) {
		FreeLibrary(hLib);
		return;
	}
	
	receivexy = (BOOL(*)(int *, int *))GetProcAddress(hLib,"receivexy");
	if(receivexy <= 0) {
		FreeLibrary(hLib);
		return;
	}
	newgame = (BOOL(*)(int))GetProcAddress(hLib,"newgame");
	if(newgame <= 0) {
		FreeLibrary(hLib);
		return;
	}

	port_num = 2;		// COM |[g̔ԍ
	PRT("COM%d open\n",port_num);
	if(!initcom(port_num)) {
		PRT("initcom error");
		return;
	}
	PRT("color:? ");
	my_color = 2;	// 
	PRT("my_color = %d\n",my_color);

	if(!newgame(my_color)) {
		PRT("newgame timeout");
		closecom();
		FreeLibrary(hLib);
		return;
	}
	PRT("Newgame starts");
	movecount = 0;
	endgameflag = FALSE;
	while (TRUE) {
		movecount++;
		teban = ((movecount+1) & 1) + 1;
		PRT("step: %d\n",movecount);
		if ( teban == my_color ) {
			x = 5;
			y = 3;
			if (!sendxy(x,y)) {
				PRT("sendxy timeout\n");
				closecom();
				FreeLibrary(hLib);
				return;
			}
			break;
		}
		else {
			do {
				ret = receivexy(&x,&y);
				if(_kbhit()) if(getch()==ESC) {
					endgameflag = TRUE;
					break;
				}
			} while (!ret);
			if(endgameflag) break;
			PRT(" x,y = %d,%d\n",x,y);
		}
	}
	closecom();
	FreeLibrary(hLib);
	PRT("end of game\n");
}
*/
/*
static HANDLE hCom;

int RS_init( ) // ʐM|[g 
{
    DCB dcb ;
    COMMTIMEOUTS CommTimeOuts ;

    if ( ( hCom = CreateFile ( "COM1", // I[vt@C "COM1" 
    GENERIC_READ | GENERIC_WRITE, // ̃t@CI[v 
    0, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL ) )
    == INVALID_HANDLE_VALUE ) {
        return 1; // error
    }

    CommTimeOuts.ReadIntervalTimeout = MAXDWORD;
    CommTimeOuts.ReadTotalTimeoutMultiplier = 0;
    CommTimeOuts.ReadTotalTimeoutConstant = 1000;
    CommTimeOuts.WriteTotalTimeoutMultiplier = 0;
    CommTimeOuts.WriteTotalTimeoutConstant = 1000;
    if ( !SetCommTimeouts( hCom, &CommTimeOuts )){
        CloseHandle(hCom);
        return 2; // SetCommTimeouts error
    }

    dcb.DCBlength = sizeof ( DCB ) ;
    dcb.BaudRate = 1200 ;
    dcb.fBinary = TRUE ;
    dcb.fParity = 0;
    dcb.fOutxCtsFlow = 0; // CTS output flow control
    dcb.fOutxDsrFlow = 0; // DSR output flow control
    dcb.fDtrControl = 1; // DTR flow control type
    dcb.fDsrSensitivity = 0; // DSR sensitivity
    dcb.fTXContinueOnXoff = 0; // XOFF continues Tx
    dcb.fOutX = 1; // XON/XOFF out flow control
    dcb.fInX = 1; // XON/XOFF in flow control
    dcb.fErrorChar = 0; // enable error replacement
    dcb.fNull = 0; // enable null stripping
    dcb.fRtsControl = 1; // RTS flow control
    dcb.fAbortOnError = 0; // abort reads/writes on error
    dcb.XonLim = 2048; // transmit XON threshold
    dcb.XoffLim = 512; // transmit XOFF threshold
    dcb.ByteSize = 8; // number of bits/byte, 4-8
    dcb.Parity = NOPARITY; // 0-4=no,odd,even,mark,space
    dcb.StopBits = ONESTOPBIT; // 0,1,2 = 1, 1.5, 2
    dcb.XonChar = 17; // Tx and Rx XON character
    dcb.XoffChar = 19; // Tx and Rx XOFF character
    dcb.ErrorChar = 0; // error replacement character
    dcb.EofChar = 0; // end of input character
    dcb.EvtChar = 0; // received event character

    if ( !SetCommState( hCom, &dcb ) ){
        CloseHandle(hCom);
        return 3;//SetCommState error
    }
    return(0);
}

void RS_close () // ʐM|[gN[Y 
{
    CloseHandle( hCom );
}


//ꎚǂݍށA
//ǂݍ񂾏ꍇ1Ԃ
//ǂݍޕȂꍇ0Ԃ

int RS_read(unsigned char *c)
{
    DWORD length;
    if( !ReadFile(hCom, c, 1, &length, NULL) ) return 0;
    return length;
}

@
void RS_send(unsigned char c)
{
    DWORD length;
    WriteFile(hCom, &c, 1, &length, NULL);
}
@

Nobuhiro Yoshimura

Konami Computer Entertainment Tokyo The opinions expressed 
Office: yosimura@konami.co.jp here are mine and not 
Home: yoshimura@acm.org necessarily those of Konami. 
*/